*       By Pradip Acharya   pacharya@look.ca   August, 2001

#DEFINE WHITESPACE CHR(32)+CHR(0)+CHR(9)+CHR(10)+CHR(11)+CHR(12)+CHR(13)+CHR(26)
**      horizontal tab      9
**      linefeed            10
**      vertical tab        11
**      formfeed            12
**      enter (CR)          13
**      ctrl+Z              26

FUNCTION StringType
LPARAMETERS m.p1cString
    PRIVATE ALL
    if .NOT.(TYPE("m.p1cString") == "C")
        return TYPE("m.p1cString") && most unlikey, but just in case
    endif

    LOCAL m.lcTrimmed, m.lcVarType, m.liI, m.liJ, m.luTemp

*   Unequivocally, eliminate leading and trailing white space

    m.liI = 0
    for m.liJ = 1 to LEN(m.p1cString)
        if .NOT.(SUBST(m.p1cString, m.liJ, 1) $ WHITESPACE)
            m.liI = m.liJ
            EXIT
        endif
    endfor
    if m.liI = 0    && nothing in the string
        return "C"
    endif
    for m.liJ = LEN(m.p1cString) to m.liI STEP -1
        if .NOT.(SUBST(m.p1cString, m.liJ, 1) $ WHITESPACE)
            EXIT
        endif
    endfor
    m.lcTrimmed = UPPER(SUBST(m.p1cString, m.liI, m.liJ-m.liI+1))

*   If it's a name of something, it must be of type character

    m.luTemp = LEFT(m.lcTrimmed, 1)
    if BETWEEN(m.luTemp, "A", "Z") or (m.luTemp == "_")
        return "C"
    endif

*   Money ?

    if m.luTemp == "$"
        if TYPE(STUFF(m.lcTrimmed, 1, 1, "")) == "N"
            return "Y"
        endif
        return "C"
    endif

*   Logical ?

    if (m.luTemp == ".") and (RIGHT(m.lcTrimmed, 1) == ".")
        if (m.lcTrimmed == ".T.") or ;
           (m.lcTrimmed == ".F.") or ;
           (m.lcTrimmed == ".TRUE.") or ;
           (m.lcTrimmed == ".FALSE.")
            return "L"
        endif
        return "C"
    endif

*   If enclosed in {}, it's type D (valid or not)

    m.liI = .F.
    m.liJ = .F.
    m.lcVarType = TYPE(m.lcTrimmed)
    if m.lcVarType == "D"
        return "D"
    endif

    m.liJ = 0
    if empty(EVALUATE("{"+m.lcTrimmed+"}"))

*       Looks like empty date - accept only // or {}

        for m.liI = 1 to LEN(m.lcTrimmed)
            m.luTemp = SUBST(m.lcTrimmed, m.liI, 1)
            if m.luTemp $ WHITESPACE
                LOOP
            endif
            if not (m.luTemp == "/")
                liJ = 0
                EXIT
            endif
            m.liJ = m.liJ + 1
            if m.liJ > 2
                EXIT
            endif
        endfor

    else   && Looks like a date - check for proper format

        if LEFT(m.lcTrimmed, 1) == "^"
            return "D"
        endif
        for m.liI = 1 to LEN(m.lcTrimmed)
            if BETWEEN(SUBST(m.lcTrimmed, m.liI, 1), "0", "9")
                LOOP
            endif
            m.liJ = m.liJ + 1
            DO CASE
            case m.liJ = 1
                m.luTemp = SUBST(m.lcTrimmed, m.liI, 1)

            case m.liJ = 2
                if not (m.luTemp == SUBST(m.lcTrimmed, m.liI, 1))
                    m.liJ = 0
                    EXIT
                endif

            other
                EXIT
            
            ENDCASE
        endfor
    endif
    if m.liJ = 2
        return "D"
    endif

*   Undefined means Character
        
    if m.lcVarType $ "UMG"
        return "C"
    endif

*   If numeric, is it an integer?

    if (m.lcVarType == "N")
        m.luTemp = EVALUATE(m.lcTrimmed)
        if m.luTemp = ROUND(m.luTemp, 0)
            return "I"
        endif
    endif
return m.lcVarType
