#INCLUDE foxpro.h

* define the Namespace and DMO CLSIDs
#DEFINE SQLDMO_CLASS		"SQLDMO.Application"
#DEFINE SQLDMO_SERVER		"SQLDMO.SQLServer"
#DEFINE SQLDMO_DATABASE		"SQLDMO.Database"
#DEFINE SQLDMO_FILE		"SQLDMO.DBFile"
#DEFINE SQLDMO_RESTORE		"SQLDMO.Restore"
#DEFINE SQLNS_CLASS	"SQLNS.SQLNamespace"

* useful constants not defined in foxpro.h
#DEFINE CR chr(13)

* connection timeout (in seconds)
#DEFINE CONNECT_TIMEOUT	10

* Named Constants for SQL Namespace
#DEFINE SQLNSROOTTYPE_SERVER	2
#DEFINE SQLNSROOTTYPE_SERVERGROUP	1
#DEFINE SQLNSROOTTYPE_DATABASE	3
#DEFINE SQLNSROOTTYPE_DEFAULTROOT	0

#DEFINE SQLNSOBJECTTYPE_ROOT	0	&& Generic root node.
#DEFINE SQLNSOBJECTTYPE_EMPTY	1	&& Generic object type.
#DEFINE SQLNSOBJECTTYPE_SERVER_GROUP	2	&& Server group.
#DEFINE SQLNSOBJECTTYPE_SERVER	3	&& Server.
#DEFINE SQLNSOBJECTTYPE_DATABASES	4	&& Databases, SQLNSRootType_Server\Databases.
#DEFINE SQLNSOBJECTTYPE_DATABASE	5	&& Specific database, SQLNSRootType_Server\Databases\master.
#DEFINE SQLNSOBJECTTYPE_MANAGEMENT	6	&& SQLNSRootType_Server\Management.
#DEFINE SQLNSOBJECTTYPE_SECURITY	7	&& Security folder SQLNSRootType_Server\Security.
#DEFINE SQLNSOBJECTTYPE_SERVICES	8	&& Services folder, SQLNSRootType_Server\Support Services.
#DEFINE SQLNSOBJECTTYPE_LOGINS	9	&& Logins.
#DEFINE SQLNSOBJECTTYPE_LOGIN	10	&& Specific user login.
#DEFINE SQLNSOBJECTTYPE_BACKUPDEVICES	11	&& Backup Devices.
#DEFINE SQLNSOBJECTTYPE_BACKUPDEVICE	12	&& Specific backup device.
#DEFINE SQLNSOBJECTTYPE_DATABASE_PUBLICATIONS	13	&& Publications in a database tree.
#DEFINE SQLNSOBJECTTYPE_DATABASE_PUBLICATION	14	&& Specific publication in a database tree.
#DEFINE SQLNSOBJECTTYPE_DATABASE_PUB_SUBSCRIPTION	15	&& Specific subscription to a publication in a database tree.
#DEFINE SQLNSOBJECTTYPE_DATABASE_PULL_SUBSCRIPTIONS	16	&& Pull subscriptions.
#DEFINE SQLNSOBJECTTYPE_DATABASE_PULL_SUBSCRIPTION	17	&& Specific pull subscription.
#DEFINE SQLNSOBJECTTYPE_DATABASE_USERS	18	&& Database Users.
#DEFINE SQLNSOBJECTTYPE_DATABASE_USER	19	&& Specific database user.
#DEFINE SQLNSOBJECTTYPE_DATABASE_ROLES	20	&& Database Roles.
#DEFINE SQLNSOBJECTTYPE_DATABASE_ROLE	21	&& Specific database role.
#DEFINE SQLNSOBJECTTYPE_DATABASE_DIAGRAMS	22	&& Database Diagrams.
#DEFINE SQLNSOBJECTTYPE_DATABASE_DIAGRAM	23	&& Internal use only, not exposed.
#DEFINE SQLNSOBJECTTYPE_DATABASE_TABLES	24	&& Tables.
#DEFINE SQLNSOBJECTTYPE_DATABASE_TABLE	25	&& Specific table.
#DEFINE SQLNSOBJECTTYPE_DATABASE_VIEWS	26	&& SQL Server Views, SQLNSRootType_Server\Databases\pubs\Views.
#DEFINE SQLNSOBJECTTYPE_DATABASE_VIEW	27	&& Specific view, SQLNSRootType_Server\Databases\pubs\Views\titleview.
#DEFINE SQLNSOBJECTTYPE_DATABASE_SPS	28	&& Stored Procedures.
#DEFINE SQLNSOBJECTTYPE_DATABASE_SP	29	&& Specific stored procedure.
#DEFINE SQLNSOBJECTTYPE_DATABASE_EXTENDED_SPS	30	&& Extended stored procedure folder, SQLNSRootType_Server\Databases\master\Extended Stored Procedures.
#DEFINE SQLNSOBJECTTYPE_DATABASE_EXTENDED_SP	31	&& Specific extended stored procedure, SQLNSRootType_Server\Databases\master\Extended Stored Procedures
#DEFINE SQLNSOBJECTTYPE_DATABASE_RULES	32	&& Rules.
#DEFINE SQLNSOBJECTTYPE_DATABASE_RULE	33	&& Specific rule.
#DEFINE SQLNSOBJECTTYPE_DATABASE_DEFAULTS	34	&& Defaults.
#DEFINE SQLNSOBJECTTYPE_DATABASE_DEFAULT	35	&& Specific default.
#DEFINE SQLNSOBJECTTYPE_DATABASE_UDDTS	36	&& User Defined Data Types.
#DEFINE SQLNSOBJECTTYPE_DATABASE_UDDT	37	&& Specific user-defined data type.
#DEFINE SQLNSOBJECTTYPE_JOBSERVER	38	&& SQL Server Agent.
#DEFINE SQLNSOBJECTTYPE_SQLMAIL	39	&& SQL Mail.
#DEFINE SQLNSOBJECTTYPE_DTC	40	&& Distributed Transaction Coordinator.
#DEFINE SQLNSOBJECTTYPE_INDEXSERVER	41	&& Index server catalog.
#DEFINE SQLNSOBJECTTYPE_INDEXSERVER_CATALOGS	42	&& Index server catalog folder.
#DEFINE SQLNSOBJECTTYPE_INDEXSERVER_CATOLOG	43	&& Specific index server catalog.
#DEFINE SQLNSOBJECTTYPE_ERRORLOGS	44	&& Error log folder, SQLNSRootType_Server\Management\SQL Server Logs.
#DEFINE SQLNSOBJECTTYPE_ERRORLOG	45	&& Specific error log, SQLNSRootType_Server\Management\SQL Server Logs\Current ? Date.
#DEFINE SQLNSOBJECTTYPE_ERRORLOGENTRY	46	&& Error log entry, SQLNSRootType_Server\Management\SQL Server Logs\Current ? Date and time.
#DEFINE SQLNSOBJECTTYPE_ALERTS	47	&& SQLNSRootType_Server\Management\SQL Server Agent\Alerts.
#DEFINE SQLNSOBJECTTYPE_OPERATORS	48	&& Specific SQL Server log.
#DEFINE SQLNSOBJECTTYPE_MSX_JOBS	49	&& Reserved.
#DEFINE SQLNSOBJECTTYPE_LOCAL_JOBS	50	&& Local jobs, SQLNSRootType_Server\Management\SQL Server Agent\Jobs.
#DEFINE SQLNSOBJECTTYPE_MULTI_JOBS	51	&& Operators.
#DEFINE SQLNSOBJECTTYPE_LOCAL_JOB	52	&& Specific local job, SQLNSRootType_Server\Management\SQL Server Agent\Jobs\test.
#DEFINE SQLNSOBJECTTYPE_MULTI_JOB	53	&& Jobs.
#DEFINE SQLNSOBJECTTYPE_REMOTESERVERS	54	&& SQLNSRootType_Server\Security\Remote Servers.
#DEFINE SQLNSOBJECTTYPE_LINKEDSERVERS	55	&& Linked server folder, SQLNSRootType_Server\Security\Linked Servers.
#DEFINE SQLNSOBJECTTYPE_SERVERROLES	56	&& Remote server folder, SQLNSRootType_Server\Security\Server Roles.
#DEFINE SQLNSOBJECTTYPE_SERVERROLE	57	&& Specific remote server.
#DEFINE SQLNSOBJECTTYPE_ALERT	58	&& SQLNSRootType_Server\Management\SQL Server Agent\Alerts\Demo: Full msdb log.
#DEFINE SQLNSOBJECTTYPE_OPERATOR	59	&& Server Roles.
#DEFINE SQLNSOBJECTTYPE_REMOTESERVER	60	&& Specific server role.
#DEFINE SQLNSOBJECTTYPE_LINKEDSERVER	61	&& Specific linked server, SQLNSRootType_Server\Security\Linked Servers\NWIND.
#DEFINE SQLNSOBJECTTYPE_LINKEDSERVER_TABLE	62	&& Linked server table, SQLNSRootType_Server\Security\Linked Servers\NWIND\Tables\Categories.
#DEFINE SQLNSOBJECTTYPE_LINKEDSERVER_TABLES	63	&& Linked server table name, SQLNSRootType_Server\Security\Linked Servers\NWIND\Tables.
#DEFINE SQLNSOBJECTTYPE_REPLICATION	64	&& Replication folder.
#DEFINE SQLNSOBJECTTYPE_REPLICATION_PUBLISHERS	65	&& Replication Publishers folder.
#DEFINE SQLNSOBJECTTYPE_REPLICATION_PUBLISHER	66	&& Specific replication Publisher.
#DEFINE SQLNSOBJECTTYPE_REPLICATION_AGENTS	67	&& Replication agents folder.
#DEFINE SQLNSOBJECTTYPE_REPLICATION_REPORTS	68	&& Reserved.
#DEFINE SQLNSOBJECTTYPE_REPLICATION_ALERTS	69	&& Replication alerts folder.
#DEFINE SQLNSOBJECTTYPE_REPLICATION_SUBSCRIPTION	70	&& Specific replication subscription.
#DEFINE SQLNSOBJECTTYPE_REPLICATION_PUBLICATION	71	&& Specific replication publication.
#DEFINE SQLNSOBJECTTYPE_REPLICATION_SNAPSHOT_AGENTS	72	&& Replication Snapshot Agents folder.
#DEFINE SQLNSOBJECTTYPE_REPLICATION_LOGREADER_AGENTS	73	&& Replication Log Reader Agents folder.
#DEFINE SQLNSOBJECTTYPE_REPLICATION_DISTRIBUTION_AGENTS	74	&& Replication Distribution Agents folder.
#DEFINE SQLNSOBJECTTYPE_REPLICATION_MERGE_AGENTS	75	&& Replication Merge Agents folder.
#DEFINE SQLNSOBJECTTYPE_REPLICATION_SNAPSHOT_AGENT	76	&& Specific replication Snapshot Agent.
#DEFINE SQLNSOBJECTTYPE_REPLICATION_LOGREADER_AGENT	77	&& Specific replication Log Reader Agent.
#DEFINE SQLNSOBJECTTYPE_REPLICATION_DISTRIBUTION_AGENT	78	&& Specific replication Distribution Agent.
#DEFINE SQLNSOBJECTTYPE_REPLICATION_MERGE_AGENT	79	&& Specific replication Merge Agent.
#DEFINE SQLNSOBJECTTYPE_REPLICATION_REPORT	80	&& Reserved.
#DEFINE SQLNSOBJECTTYPE_DTS_LOCALPKGS	82	&& DTS packages saved to Microsoft? SQL Server? 2000.
#DEFINE SQLNSOBJECTTYPE_DTS_REPOSPKGS	83	&& DTS packages saved to repository.
#DEFINE SQLNSOBJECTTYPE_DTSPKGS	83	&& DTS Packages.
#DEFINE SQLNSOBJECTTYPE_DTSCATEGORIES	85	&& Reserved.
#DEFINE SQLNSOBJECTTYPE_DTSCATEGORY	85	&& Reserved.
#DEFINE SQLNSOBJECTTYPE_DTS_METADATA	86	&& DTS package meta data folder.
#DEFINE SQLNSOBJECTTYPE_DTSPKG	86	&& Specific DTS package.
#DEFINE SQLNSOBJECTTYPE_DTSSTEPS	87	&& Reserved.
#DEFINE SQLNSOBJECTTYPE_DTSCONNECTIONS	88	&& Reserved.
#DEFINE SQLNSOBJECTTYPE_DTSSTEP	89	&& Reserved.
#DEFINE SQLNSOBJECTTYPE_DTSCONNECTION	90	&& Reserved.
#DEFINE SQLNSOBJECTTYPE_DB_MAINT_PLANS	91	&& Database Maintenance Plans.
#DEFINE SQLNSOBJECTTYPE_DB_MAINT_PLAN	92	&& Specific database maintenance plan.
#DEFINE SQLNSOBJECTTYPE_WEBASSISTANTJOBS	93	&& Web Assistant Jobs.
#DEFINE SQLNSOBJECTTYPE_WEBASSISTANTJOB	94	&& Specific Web Assistant job.
#DEFINE SQLNSOBJECTTYPE_CURRENTACTIVITY	95	&& SQLNSRootType_Server\Management\Current Activity.
#DEFINE SQLNSOBJECTTYPE_CURRENTACTIVITY_ USERS	96	&& Reserved.
#DEFINE SQLNSOBJECTTYPE_CURRENTACTIVITY_LOGIN	97	&& Reserved.
#DEFINE SQLNSOBJECTTYPE_CURRENTACTIVITY_PROCESSINFO	98	&& SQLNSRootType_Server\Management\Current Activity\Process Info.
#DEFINE SQLNSOBJECTTYPE_CURRENTACTIVITY_PROCESSINFO_INFO	99	&& SQLNSRootType_Server\Management\Current Activity\Process Info\1.
#DEFINE SQLNSOBJECTTYPE_CURRENTACTIVITY_LOCKEDOBJECTS	100	&& SQLNSRootType_Server\Management\Current Activity\Locks\Object.
#DEFINE SQLNSOBJECTTYPE_CURRENTACTIVITY_LOCKEDOBJECT	101	&& SQLNSRootType_Server\Management\Current Activity\Locks\Object\master.
#DEFINE SQLNSOBJECTTYPE_DATABASE_UDFS	101	&& User-defined Functions folder.
#DEFINE SQLNSOBJECTTYPE_CURRENTACTIVITY_LOCKEDOBJECT_INFO	102	&& SQLNSRootType_Server\Management\Current Activity\Locks\Object\master\1.
#DEFINE SQLNSOBJECTTYPE_DATABASE_UDF	102	&& Specific user-defined function.
#DEFINE SQLNSOBJECTTYPE_PROFILER	103	&& SQL Server Performance Analysis Traces in the Management folder.
#DEFINE SQLNSOBJECTTYPE_PROFILER_TRACE	104	&& Reserved.
#DEFINE SQLNSOBJECTTYPE_REPLICATION_MONITOR_GROUP	105	&& Replication monitor group folder.
#DEFINE SQLNSOBJECTTYPE_REPLICATION_QUEUEREADER_AGENTS	106	&& Replication Queue Reader Agents Folder.
#DEFINE SQLNSOBJECTTYPE_REPLICATION_QUEUEREADER_AGENT	107	&& Specific replication Queue Reader Agent.
#DEFINE SQLNSOBJECTTYPE_LOGSHIPPING_MONITORS	108	&& Log Shipping monitor folder.
#DEFINE SQLNSOBJECTTYPE_LOGSHIPPING_MONITOR	109	&& Specific Log Shipping monitor.
#DEFINE SQLNSOBJECTTYPE_REPLICATION_FOLDER	110	&& Replication folder.
#DEFINE SQLNSOBJECTTYPE_PUBLICATIONS_FOLDER	111	&& Publications folder in the Replication folder.
#DEFINE SQLNSOBJECTTYPE_SUBSCRIPTIONS_FOLDER	112	&& Subscriptions folder in the Replication folder.
#DEFINE SQLNSOBJECTTYPE_REPLICATION_FOLDER_PUBLICATION	113	&& Specific publication in the Publications folder.
#DEFINE SQLNSOBJECTTYPE_REPLICATION_FOLDER_PUB_SUBSCRIPTION	114	&& Specific subscription to a publication in the Publications folder.
#DEFINE SQLNSOBJECTTYPE_REPLICATION_FOLDER_SUBSCRIPTION	115	&& Specific pull subscription in the Subscriptions folder.
#DEFINE SQLNSOBJECTTYPE_REPLICATION_FOLDER_PUSH_SUBSCRIPTION	116	&& Specific push subscription in the Subscriptions folder.
#DEFINE SQLNSOBJECTTYPE_HETEROGENEOUS_PUBLICATIONS_FOLDER	117	&& Heterogeneous Publications folder.
#DEFINE SQLNSOBJECTTYPE_HETEROGENEOUS_PUBLICATION	118	&& Specific heterogeneous publication.
#DEFINE SQLNSOBJECTTYPE_HETEROGENEOUS_PUB_SUBSCRIPTION	119	&& Subscription to a heterogeneous publication.
#DEFINE SQLNSOBJECTTYPE_HETEROGENEOUS_VENDOR_FOLDER	120	&& Heterogeneous Vendors folder.
#DEFINE SQLNSOBJECTTYPE_LINKEDSERVER_VIEWS	121	&& Linked server views folder.
#DEFINE SQLNSOBJECTTYPE_LINKEDSERVER_VIEW	122	&& Specific linked server view

* name of the table that stores version information and identifies a database as belonging to this application
#DEFINE METADATA_TABLE	"MyApp_MetaData"

* Strings for localisation
#DEFINE OBJECTS_NOT_INSTALLED	"The following COM objects are not installed:"
#DEFINE SQL_NAMESPACE	" SQL Namespace"
#DEFINE SQL_DMO	" SQL Distributed Management Objects"
#DEFINE SQL_DMO_SERVER	" SQL Distributed Management Object Server"
#DEFINE SQL_DMO_FILE	" SQL Distributed Management Object File"
#DEFINE NOT_INSTALLED_TITLE  "Cannot start maintenance module"
#DEFINE PLEASE_CONTACT_SYSADMIN  "Please contact your system administrator or reseller"
#DEFINE ERROR_INSTANTAITING_OBJECT  "The following COM objects could not be created:"
#DEFINE COULD_NOT_INSTANTIATE_TITLE "Cannot start maintenance module"
#DEFINE COULD_NOT_CONNECT_TITLE	"Cannot connect to SQL Server"
#DEFINE ERROR_CONNECTING_TO_SERVER 	"There was an error connecting to the SQL Server"
#DEFINE UNABLE_TO_DISPLAY_PROPERTIES	"Unable to display database properties"
#DEFINE UNABLE_TO_UPDATE_DATABASE		"Unable to update database structure"
#DEFINE UNABLE_TO_SCHEDULE_BACKUPS	"Unable to schedule backups"
#DEFINE UNABLE_TO_MAINTAIN_USERS	"Unable to launch user maintenance"
#DEFINE SELECT_A_DATABASE	"Please choose a database from the list"

#DEFINE NEW_FILE_LOCATION_TITLE	'Location and file name for new data file'
#DEFINE DATABASE_FILE_TYPES	'Database File (*.mdf):mdf'
#DEFINE FILE_ALREADY_EXISTS	'That file already exists - please specify a new name for the database data file'
#DEFINE UNABLE_TO_CREATE_DATABASE 'Unable to create new database'
#DEFINE FILE_LOCATION_CAPTION	'File location'
#DEFINE NEW_CAPTION	'New'
#DEFINE PATH_DOES_NOT_EXIST	"The specified path does not exist"
#DEFINE DATABASE_NAME_IN_USE	"The database name ##DB_NAME## alreay exists on this server" + CR + "Please choose another database name"
#DEFINE ERROR_CREATING_DATABASE	"There was an unspecified error creating the database"

#DEFINE ERROR_UPDATING_DATABASE	"There was an error updating the database"
#DEFINE ODBC_MESSAGE	"The ODBC Error Message was:"

#DEFINE BACKUPFILE_DOES_NOT_EXIST 	"The backup file specified does not exist"

#DEFINE DATABASE_IS_UP_TO_DATE	"The database ##DBNAME## is up to date"

* form caption
#DEFINE BASE_CAPTION	"Database Maintenance"

#DEFINE APPLYING_VERSION	"Updating structure to version "
#DEFINE VERSION_UPDATE_COMPLETE	"Structure update complete"

** Connect string templates
#DEFINE CONNECT_STRING_TRUSTED "server=##SERVER_NAME##;driver={SQL Server};database=##DATABASE_NAME##;Trusted_Connection=Yes"
#DEFINE CONNECT_STRING_SQL	"server=##SERVER_NAME##;driver={SQL Server};database=##DATABASE_NAME##;UID=##USER_ID##;pwd=##PASSWORD##"
